## bowtie2 2.4.1

=== Makefile ===
#
# Copyright 2011, Ben Langmead <langmea@cs.jhu.edu>
#
# This file is part of Bowtie 2.
#
# Bowtie 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Bowtie 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bowtie 2.  If not, see <http://www.gnu.org/licenses/>.
#

#
# Makefile for bowtie, bowtie2-build, bowtie2-inspect
#

PREFIX := /usr/local
bindir := $(PREFIX)/bin

LDLIBS := -lz
GCC_PREFIX := $(shell dirname `which gcc`)
GCC_SUFFIX :=
CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX ?= $(CPP)

HEADERS := $(wildcard *.h)
BOWTIE_MM := 1
BOWTIE_SHARED_MEM :=

NGS_VER ?= 2.9.2
VDB_VER ?= 2.9.2-1

# Detect Cygwin or MinGW
WINDOWS :=
MINGW :=
ifneq (,$(findstring MINGW,$(shell uname)))
  WINDOWS := 1
  MINGW := 1
  # POSIX memory-mapped files not currently supported on Windows
  BOWTIE_MM :=
  BOWTIE_SHARED_MEM :=
endif

MACOS :=
ifneq (,$(findstring Darwin,$(shell uname)))
  MACOS := 1
  ifeq (1,$(shell uname -r | awk -F. '{ if ($$1 > 12 && $$1 < 16) print 1; }'))
	CXXFLAGS += -stdlib=libstdc++
  endif
  ifdef STATIC_BUILD
	CXXFLAGS += -mmacosx-version-min=10.9
  endif
endif

ifdef STATIC_BUILD
  LDFLAGS += -L$(CURDIR)/.tmp/lib
  CPPFLAGS += -I$(CURDIR)/.tmp/include
endif

POPCNT_CAPABILITY ?= 1
ifeq (1, $(POPCNT_CAPABILITY))
  CXXFLAGS += -DPOPCNT_CAPABILITY
  CPPFLAGS += -I third_party
endif

MM_DEF :=

ifeq (1,$(BOWTIE_MM))
  MM_DEF := -DBOWTIE_MM
endif

SHMEM_DEF :=

ifdef BOWTIE_SHARED_MEM
  SHMEM_DEF := -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG :=
PTHREAD_LIB :=

#if we're not using TBB, then we can't use queuing locks
ifeq (1,$(NO_TBB))
  NO_QUEUELOCK := 1
endif

ifeq (1,$(MINGW))
  PTHREAD_LIB :=
else
  PTHREAD_LIB := -lpthread
endif

ifeq (1,$(NO_SPINLOCK))
  CXXFLAGS += -DNO_SPINLOCK
endif

#default is to use Intel TBB
ifneq (1,$(NO_TBB))
  LDLIBS += $(PTHREAD_LIB) -ltbb
  ifdef STATIC_BUILD
    LDLIBS += -ltbbmalloc
    ifndef MINGW
      LDLIBS += -ldl
    endif
  else
    LDLIBS += -ltbbmalloc_proxy
  endif
  CXXFLAGS += -DWITH_TBB -std=c++11
else
  LDLIBS += $(PTHREAD_LIB)
endif

USE_SRA ?=
ifeq (1, $(USE_SRA))
  ifdef MINGW
    $(error "SRA binaries cannot be built on MINGW")
  else
    LDFLAGS += -L$(CURDIR)/.tmp/lib64
    ifndef ($(STATIC_BUILD))
      CPPFLAGS += -I$(CURDIR)/.tmp/include
    endif
    LDLIBS += -lncbi-ngs-c++-static
    LDLIBS += -lngs-c++-static
    LDLIBS += -lncbi-vdb-static
    LDLIBS += -ldl
    CXXFLAGS += -DUSE_SRA
  endif
endif

ifeq (1,$(WITH_THREAD_PROFILING))
  CXXFLAGS += -DPER_THREAD_TIMING=1
endif

ifeq (1,$(WITH_AFFINITY))
  CXXFLAGS += -DWITH_AFFINITY=1
endif

#default is to use Intel TBB's queuing lock for better thread scaling performance
ifneq (1,$(NO_QUEUELOCK))
  CXXFLAGS += -DNO_SPINLOCK
  CXXFLAGS += -DWITH_QUEUELOCK=1
endif

SHARED_CPPS :=  ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
  edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
  reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
  random_source.cpp

ifeq (1,$(NO_TBB))
  SHARED_CPPS += tinythread.cpp
endif

SEARCH_CPPS :=  qual.cpp pat.cpp sam.cpp \
  read_qseq.cpp aligner_seed_policy.cpp \
  aligner_seed.cpp \
  aligner_seed2.cpp \
  aligner_sw.cpp \
  aligner_sw_driver.cpp aligner_cache.cpp \
  aligner_result.cpp ref_coord.cpp mask.cpp \
  pe.cpp aln_sink.cpp dp_framer.cpp \
  scoring.cpp presets.cpp unique.cpp \
  simple_func.cpp \
  random_util.cpp \
  aligner_bt.cpp sse_util.cpp \
  aligner_swsse.cpp outq.cpp \
  aligner_swsse_loc_i16.cpp \
  aligner_swsse_ee_i16.cpp \
  aligner_swsse_loc_u8.cpp \
  aligner_swsse_ee_u8.cpp \
  aligner_driver.cpp

SEARCH_CPPS_MAIN := $(SEARCH_CPPS) bowtie_main.cpp

DP_CPPS := qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
  simple_func.cpp sse_util.cpp aligner_bt.cpp aligner_swsse.cpp \
  aligner_swsse_loc_i16.cpp aligner_swsse_ee_i16.cpp \
  aligner_swsse_loc_u8.cpp aligner_swsse_ee_u8.cpp scoring.cpp

BUILD_CPPS := diff_sample.cpp
BUILD_CPPS_MAIN := $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS := $(wildcard search_*_phase*.c)
VERSION := $(shell cat VERSION)

SANITIZER_FLAGS :=
ifeq (0,$(shell $(CXX) -E -fsanitize=address,undefined btypes.h > /dev/null 2>&1; echo $$?))
  SANITIZER_FLAGS := -fsanitize=address,undefined
else ifeq (0,$(shell $(CXX) -E -fsanitize=address btypes.h > /dev/null 2>&1; echo $$?))
  SANITIZER_FLAGS := -fsanitize=address
else ifeq (0,$(shell $(CXX) -E -fsanitize=undefined btypes.h > /dev/null 2>&1; echo $$?))
  SANITIZER_FLAGS := -fsanitize=undefined
endif

BITS := 32
SSE_FLAG := -msse2
ifeq (x86_64,$(shell uname -m))
  BITS := 64
else ifeq (amd64,$(shell uname -m))
  BITS := 64
else ifeq (aarch64,$(shell uname -m))
  BITS := 64
  SSE_FLAG :=
  CXXFLAGS := -fopenmp-simd
  CPPFLAGS := -Ithird_party/simde
else ifeq (s390x,$(shell uname -m))
  BITS := 64
  SSE_FLAG :=
  CXXFLAGS := -fopenmp-simd
  CPPFLAGS := -Ithird_party/simde
  SANITIZER_FLAGS :=
else ifeq (ppc64le,$(shell uname -m))
  BITS := 64
  SSE_FLAG :=
  CXXFLAGS := -fopenmp-simd
  CPPFLAGS += -Ithird_party/simde
  SANITIZER_FLAGS :=
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
  ifeq (1,$(MINGW))
    BITS := 64
  endif
endif
ifeq (32,$(BITS))
  $(error bowtie2 compilation requires a 64-bit platform )
endif

DEBUG_FLAGS    := -O0 -g3 $(SSE_FLAG)
RELEASE_FLAGS  := -O3 $(SSE_FLAG) -funroll-loops -g3
NOASSERT_FLAGS := -DNDEBUG
FILE_FLAGS     := -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(CXXFLAGS)\""
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(CXXFLAGS)\""

BOWTIE2_BIN_LIST := bowtie2-build-s \
  bowtie2-build-l \
  bowtie2-align-s \
  bowtie2-align-l \
  bowtie2-inspect-s \
  bowtie2-inspect-l
BOWTIE2_BIN_LIST_DBG := bowtie2-build-s-debug \
  bowtie2-build-l-debug \
  bowtie2-align-s-debug \
  bowtie2-align-l-debug \
  bowtie2-inspect-s-debug \
  bowtie2-inspect-l-debug
BOWTIE2_BIN_LIST_SAN := bowtie2-build-s-sanitized \
  bowtie2-build-l-sanitized \
  bowtie2-align-s-sanitized \
  bowtie2-align-l-sanitized \
  bowtie2-inspect-s-sanitized \
  bowtie2-inspect-l-sanitized
ifndef SANITIZER_FLAGS
        BOWTIE2_BIN_LIST_SAN =
endif

GENERAL_LIST := $(wildcard scripts/*.sh) \
  $(wildcard scripts/*.pl) \
  doc/manual.html \
  doc/README \
  doc/style.css \
  $(wildcard example/index/*.bt2) \
  $(wildcard example/reads/*.fq) \
  $(wildcard example/reads/*.pl) \
  example/reads/combined_reads.bam \
  example/reference/lambda_virus.fa \
  $(PTHREAD_PKG) \
  bowtie2 \
  bowtie2-build \
  bowtie2-inspect \
  AUTHORS \
  LICENSE \
  NEWS \
  MANUAL \
  MANUAL.markdown \
  README.md \
  TUTORIAL \
  VERSION

ifeq (1,$(WINDOWS))
  BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
  ifneq (1,$(NO_TBB))
    CXXFLAGS += -static-libgcc -static-libstdc++
  else
    CXXFLAGS += -static -static-libgcc -static-libstdc++
  endif
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND := $(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
  $(wildcard *.hh) \
  $(wildcard *.c) \
  $(wildcard *.cpp) \
  $(wildcard third_party/*) \
  Makefile \
  CMakeLists.txt \
  $(GENERAL_LIST)

ifeq (1,$(WINDOWS))
  BIN_PKG_LIST := $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
else
  BIN_PKG_LIST := $(GENERAL_LIST)
endif

.PHONY: all allall both both-debug

all: $(BOWTIE2_BIN_LIST) ;
allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_DBG) $(BOWTIE2_BIN_LIST_SAN) ;
both: bowtie2-align-s bowtie2-build-s bowtie2-align-l bowtie2-build-l ;
both-debug: bowtie2-align-s-debug bowtie2-build-s-debug bowtie2-align-l-debug bowtie2-build-l-debug ;
both-sanitized: bowtie2-align-s-sanitized bowtie2-build-s-sanitized bowtie2-align-l-sanitized bowtie2-build-l-sanitized ;

DEFS := -fno-strict-aliasing \
  -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
  -DBUILD_HOST="\"${HOSTNAME:-`hostname`}\"" \
  -DBUILD_TIME="\"`date -u`\"" \
  -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
  $(FILE_FLAGS) \
  $(PREF_DEF) \
  $(MM_DEF) \
  $(SHMEM_DEF)

# set compiler flags for all sanitized builds
ifdef BOWTIE2_BIN_LIST_SAN
$(BOWTIE2_BIN_LIST_SAN): CXXFLAGS+=$(SANITIZER_FLAGS)
else
$(BOWTIE2_BIN_LIST_SAN): $(error "Compiler does not support...")
endif

#
# bowtie2-build targets
#

bowtie2-build-s-sanitized bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-sanitized bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-align targets
#

bowtie2-align-s-sanitized bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-sanitized bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-inspect targets
#

bowtie2-inspect-s-sanitized bowtie2-inspect-s: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-l-sanitized bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(CPPFLAGS) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LDFLAGS) $(LDLIBS)

=== debian/changelog ===
bowtie2 (2.4.1-6) unstable; urgency=medium

  * Team upload.
  * Bump version requirement for libsimde-dev to grab ppc64el fixes.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 01 Jun 2020 15:40:38 +0200

bowtie2 (2.4.1-5) unstable; urgency=medium

  * Reproducible builds: filter out -ffile-prefix-map
    Closes: #961494

 -- Andreas Tille <tille@debian.org>  Mon, 25 May 2020 14:14:23 +0200

bowtie2 (2.4.1-4) unstable; urgency=medium

  * Team upload.
  * Switch to libsimde-dev package from our code copy

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 21 Apr 2020 15:35:11 +0200

bowtie2 (2.4.1-3) UNRELEASED; urgency=medium

  * Team upload.
  * Add salsa-ci file (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 20 Apr 2020 17:54:38 +0200

bowtie2 (2.4.1-2) unstable; urgency=medium

  * Add patch fixing FTBFS with gcc10, thanks to Jun Aruga
    Closes: #957054

 -- Alexandre Mestiashvili <mestia@debian.org>  Sun, 19 Apr 2020 11:11:42 +0200

bowtie2 (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * debian/control: not ready for 32-bit archs, and those builds often take
    2-3+ hours to fail, so lets be nice and skip them.
    Patches to fix 32-bit archs are very welcomed!
  * Standards-Version: 4.5.0 (routine-update)
  * Freshen patches
  * debian/upstream/metadata: Add Bug-{Database,Submit},Repository{,-Browse}
  * Update SIMDe version to 2a9ff6ddabfb940bdd29a0a0cd1ae3190f5fc97b 2020-04-03

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 01 Mar 2020 11:30:50 +0100

=== debian/control ===
Source: bowtie2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Alexandre Mestiashvili <mestia@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               help2man,
               libtbb-dev,
               python3,
               liblocal-lib-perl,
               libtest-deep-perl,
               libclone-perl,
               libfile-which-perl,
               zlib1g-dev,
               libsimde-dev (>= 0.0.0.git.20200526)
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
Homepage: http://bowtie-bio.sourceforge.net/bowtie2

Package: bowtie2
Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 m68k ppc64 riscv64 sh4 sparc64
# "any-64bit" :-)
Built-Using: ${simde:Built-Using}
Depends: python3,
         ${misc:Depends},
         ${shlibs:Depends},
         ${perl:Depends}
Suggests: bowtie2-examples
Description: ultrafast memory-efficient short read aligner
 is an ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes

Package: bowtie2-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: bowtie2
Enhances: bowtie2
Description: Examples for bowtie2
 An ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes
 .
 This package provides some example data to work with bowtie2.

=== debian/rules ===
#!/usr/bin/make -f

pkg := bowtie2

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
export LANG=C
export LC_ALL=C.UTF-8

include /usr/share/dpkg/architecture.mk
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

EXTRA_OPTIONS =
ifneq ($(DEB_TARGET_ARCH),amd64)
        EXTRA_OPTIONS += NO_TBB=1 POPCNT_CAPABILITY=
else
        EXTRA_OPTIONS += POPCNT_CAPABILITY=1
endif

export EXTRA_OPTIONS

%:
	dh $@

override_dh_auto_build:
	LD_PRELOAD= dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_PRELOAD= $(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
	  bowtie2-build-s-debug \
	  bowtie2-build-l-debug \
	  bowtie2-align-s-debug \
	  bowtie2-align-l-debug \
	  bowtie2-inspect-s-debug \
	  bowtie2-inspect-l-debug
	LD_PRELOAD= make -j1 test
endif

override_dh_auto_install:
	dh_auto_install

override_dh_install:
	dh_install -X.gitignore

override_dh_installman:
	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
	debian/help2man-wrapper $(pkg) "wrapper for $(pkg)-align-*"
	debian/help2man-wrapper $(pkg)-build "wrapper for $(pkg)-build-*"
	debian/help2man-wrapper $(pkg)-build-l "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-build-s "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-inspect "wrapper for $(pkg)-inspect-* index"
	debian/help2man-wrapper $(pkg)-inspect-l "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-inspect-s "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-align-l "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	debian/help2man-wrapper $(pkg)-align-s "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	rm -f $(CURDIR)/debian/$(pkg)/usr/bin/bowtie2-buildc

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

## bowtie2 2.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0005 NEW)

file(STRINGS ${CMAKE_SOURCE_DIR}/BOWTIE2_VERSION PROJECT_VERSION)
project(bowtie2 LANGUAGES CXX VERSION ${PROJECT_VERSION})

enable_testing()

include(CTest)
include(ExternalProject)
include(ProcessorCount)
include(CheckSymbolExists)

ProcessorCount(NUM_CORES)

option(BOWTIE_MM "enable bowtie2 memory mapping" ON)
option(BOWITE_SHARED_MM "enable shared memory mapping" ON)

set(NO_TBB ${NO_TBB})
set(NO_SPINLOCK ${NO_SPINLOCK})
set(USE_SRA ${USE_SRA})
set(WITH_THREAD_PROFILING ${WITH_THREAD_PROFILING})
set(NO_POPCNT_CAPABILITY ${NO_POPCNT_CAPABILITY})
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -g3 -Wall -msse2")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops")
set(INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")

set(CMAKE_EXPORT_COMPILE_COMMANDS on)

if (MINGW)
  option(BOWTIE_MM "Memory mapped files not supported on Windows" OFF)
  option(BOWTIE_SHARED_MEM "Shared memory not supported on Windows" OFF)
endif(MINGW)

if (APPLE)
  set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif(APPLE)

set(BOWTIE2_BIN_LIST
  bowtie2-build-s
  bowtie2-build-l
  bowtie2-align-s
  bowtie2-align-l
  bowtie2-inspect-s
  bowtie2-inspect-l
  )

set(BOWTIE2_WRAPPER_SCRIPTS
  bowtie2
  bowtie2-build
  bowtie2-inspect
  )

set(SHARED_CPPS
  ccnt_lut.cpp
  ref_read.cpp
  alphabet.cpp
  shmem.cpp
  edit.cpp
  bt2_idx.cpp
  bt2_io.cpp
  bt2_util.cpp
  reference.cpp
  ds.cpp
  multikey_qsort.cpp
  limit.cpp
  random_source.cpp
  )

set(SEARCH_CPPS
  qual.cpp pat.cpp sam.cpp
  read_qseq.cpp aligner_seed_policy.cpp
  aligner_seed.cpp
  aligner_seed2.cpp
  aligner_sw.cpp
  aligner_sw_driver.cpp aligner_cache.cpp
  aligner_result.cpp ref_coord.cpp mask.cpp
  pe.cpp aln_sink.cpp dp_framer.cpp
  scoring.cpp presets.cpp unique.cpp
  simple_func.cpp
  random_util.cpp
  aligner_bt.cpp sse_util.cpp
  aligner_swsse.cpp outq.cpp
  aligner_swsse_loc_i16.cpp
  aligner_swsse_ee_i16.cpp
  aligner_swsse_loc_u8.cpp
  aligner_swsse_ee_u8.cpp
  aligner_driver.cpp
  bowtie_main.cpp
  bt2_search.cpp
  )

set(BUILD_CPPS
  bt2_build.cpp
  diff_sample.cpp
  bowtie_build_main.cpp)

set(INSPECT_CPPS
  bt2_inspect.cpp
  )

string(TIMESTAMP BUILD_DATE)
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -v OUTPUT_VARIABLE COMPILER_VERSION)

add_definitions(
  -DBOWTIE2
  -DBUILD_HOST="${CMAKE_HOST_SYSTEM}"
  -DBUILD_TIME="${BUILD_DATE}"
  -DCOMPILER_VERSION="${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}"
  -DBOWTIE2_VERSION="${PROJECT_VERSION}"
  -D_LARGEFILE_SOURCE
  -D_FILE_OFFSET_BITS=64
  -D_GNU_SOURCE
  )

if (WITH_AFFINITY)
  add_definitions(-DWITH_AFFINITY=1)
endif()

if (NO_SPINLOCK)
  add_definitions(-DNO_SPINLOCK)
endif()

if (NOT NO_POPCNT_CAPABILITY)
  add_definitions(-DPOPCNT_CAPABILITY)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I third_party")
endif()

if (USE_SRA)
  set(NGS_VER 2.9.2)
  set(NCBI_VDB_VER 2.9.2-1)

  find_package(Java COMPONENTS Development REQUIRED)
  find_package(PythonInterp REQUIRED)
  find_package(Perl REQUIRED)

  find_program(MAKE_EXE NAMES gmake nmake make)
  ExternalProject_add(ngs_project
    URL https://github.com/ncbi/ngs/archive/${NGS_VER}.tar.gz
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/ngs-${NGS_VER}
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ./configure --prefix=install
    BUILD_COMMAND ${MAKE_EXE}
    INSTALL_COMMAND ${MAKE_EXE} install
    )

  ExternalProject_Get_Property(ngs_project SOURCE_DIR)
  set(NGS_INSTALL_DIR ${SOURCE_DIR}/ngs-sdk/install)

  link_directories(${NGS_INSTALL_DIR}/lib64)
  include_directories(${NGS_INSTALL_DIR}/include)

  add_library(ngs-c++-static STATIC IMPORTED)
  add_dependencies(ngs-c++-static ngs_project)
  find_library(LIBNGS_CPP ngs-c++-static PATHS ${NGS_INSTALL_DIR}/lib64 NO_DEFAULT_PATH)
  set_property(TARGET ngs-c++-static PROPERTY IMPORTED_LOCATION ${LIBNGS_CPP})

  link_libraries(ngs-c++-static)

  ExternalProject_add(ncbi_vdb_project
    URL https://github.com/ncbi/ncbi-vdb/archive/${NCBI_VDB_VER}.tar.gz
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/ncbi-vdb-${NCBI_VDB_VER}
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND ./configure --prefix=install --with-ngs-sdk=${NGS_INSTALL_DIR}
    BUILD_COMMAND ${MAKE_EXE}
    INSTALL_COMMAND ${MAKE_EXE} install
    DEPENDS ngs_project
    )

  ExternalProject_Get_Property(ncbi_vdb_project SOURCE_DIR)
  set(NCBI_VDB_INSTALL_DIR ${SOURCE_DIR}/install)

  link_directories(${NCBI_VDB_INSTALL_DIR}/lib64)
  include_directories(${NCBI_VDB_INSTALL_DIR}/include)

  add_library(ncbi-ngs-c++-static STATIC IMPORTED)
  add_dependencies(ncbi-ngs-c++-static ncbi_vdb_project)
  find_library(LIBNCBI_NGS_CPP ncbi-ngs-c++-static PATHS ${NCBI_VDB_INSTALL_DIR}/lib64 NO_DEFAULT_ATH)
  set_property(TARGET ncbi-ngs-c++-static PROPERTY IMPORTED_LOCATION ${LIBNCBI_NGS_CPP})

  add_library(ncbi-vdb-static STATIC IMPORTED)
  add_dependencies(ncbi-vdb-static ncbi_vdb_project)
  find_library(LIBNCBI_VDB ncbi-vdb-static PATHS ${NCBI_VDB_INSTALL_DIR}/lib64 NO_DEFAULT_PATH)
  set_property(TARGET ncbi-vdb-static PROPERTY IMPORTED_LOCATION ${LIBNCBI_VDB})

  link_libraries(ncbi-ngs-c++-static ncbi-vdb-static)
  add_definitions(-DUSE_SRA)
endif()

if (WITH_THREAD_PROFILING)
  add_definitions(-DPER_THREAD_TIMING=1)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
  add_definitions(-DNDEBUG)
endif()

find_package(ZLIB REQUIRED)


find_package(Threads REQUIRED)
link_libraries(Threads::Threads)

if (NO_TBB)
  set(SHARED_CPPS ${SHARED_CPPS} tinythread.cpp)
else()
  find_library(TBB_LIB_PATH tbb)
  if (TBB_LIB_PATH)
    find_path(TBB_INCLUDE_PATH tbb/tbb.h)
    link_libraries(${TBB_LIB_PATH})
    find_library(TBBMALLOC_PROXY_LIB_PATH tbbmalloc_proxy)
    if (NOT TBBMALLOC_PROXY_LIB_PATH)
      find_library(TBBMALLOC_LIB_PATH tbbmalloc)
      link_libraries(${TBBMALLOC_LIB_PATH})
    else()
      link_libraries(${TBBMALLOC_PROXY_LIB_PATH})
    endif()
    include_directories(${TBB_INCLUDE_PATH})
  else()
    set(TBB_VER 2019_U4)

    if (CMAKE_SYSTEM_NAME STREQUAL Linux)
      set(tbb_os linux)
    elseif (CMAKE_SYSTEM_NAME STREQUAL Darwin)
      set(tbb_os macos)
    elseif (CMAKE_SYSTEM_NAME STREQUAL Windows)
      set(tbb_os windows)
    else()
      set(tbb_os ${CMAKE_SYSTEM_NAME})
    endif()

    find_program(MAKE_EXE NAMES gmake nmake make)
    ExternalProject_Add(tbb_project
      URL https://github.com/01org/tbb/archive/2019_U4.tar.gz
      PREFIX ${CMAKE_CURRENT_BINARY_DIR}/tbb-${TBB_VER}
      BUILD_IN_SOURCE 1
      CONFIGURE_COMMAND ""
      BUILD_COMMAND ${MAKE_EXE} tbb_build_prefix=${TBB_VER} tbb_os=${tbb_os}
      INSTALL_COMMAND ""
      PREFIX=${CMAKE_CURRENT_BINARY_DIR}/tbb_project
      )

    ExternalProject_Get_Property(tbb_project SOURCE_DIR)
    set(TBB_SOURCE_DIR ${SOURCE_DIR})
    set(TBB_RELEASE_DIR ${TBB_SOURCE_DIR}/build/${TBB_VER}_release)
    include_directories(${TBB_SOURCE_DIR}/include)
    find_path(TBB_INCLUDE_PATH PATHS ${TBB_SOURCE_DIR}/include NAMES tbb/tbb.h)

    link_directories(${TBB_RELEASE_DIR})
    add_library(tbb SHARED IMPORTED)
    add_dependencies(tbb tbb_project)
    find_library(LIBTBB tbb PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
    set_property(TARGET tbb PROPERTY IMPORTED_LOCATION ${LIBTBB})

    add_library(tbbmalloc_proxy SHARED IMPORTED)
    add_dependencies(tbbmalloc_proxy tbb_project)
    find_library(LIBTBBMALLOC_PROXY tbbmalloc_proxy PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
    if (NOT LIBTBBMALLOC_PROXY)
      add_library(tbbmalloc SHARED IMPORTED)
      add_dependencies(tbbmalloc tbb_project)
      find_library(LIBTBBMALLOC tbbmalloc PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
      set_property(TARGET tbbmalloc PROPERTY IMPORTED_LOCATION ${LIBTBBMALLOC})
      link_libraries(tbb tbbmalloc)
    else()
      set_property(TARGET tbbmalloc_proxy PROPERTY IMPORTED_LOCATION ${LIBTBBMALLOC_PROXY})
      link_libraries(tbb tbbmalloc_proxy)
    endif()
  endif()
  add_definitions(-DWITH_TBB -DWITH_QUEUELOCK=1 -DNO_SPINLOCK)
endif()

if (ZLIB_FOUND)
  link_libraries(${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()

include_directories(${PROJECT_SOURCE_DIR})
get_directory_property(COMPILER_DEFS COMPILE_DEFINITIONS)
add_definitions(-DCOMPILER_OPTIONS="${CMAKE_CXX_FLAGS}")

add_executable(bowtie2-align-s ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-align-l ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-s ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-l ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-s ${INSPECT_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-l ${INSPECT_CPPS} ${SHARED_CPPS})

set_target_properties(bowtie2-align-l bowtie2-build-l bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE2_64BIT_INDEX")
set_target_properties(bowtie2-inspect-s bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE_INSPECT_MAIN")
# set_target_properties(${BOWTIE2_BIN_LIST} PROPERTIES DEBUG_POSTFIX -debug)

install(TARGETS ${BOWTIE2_BIN_LIST} DESTINATION bin)
install(FILES ${BOWTIE2_WRAPPER_SCRIPTS}
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  DESTINATION bin)
if (LIBTBB)
  install(FILES ${LIBTBB} DESTINATION lib)
  install(DIRECTORY ${TBB_INCLUDE_PATH} DESTINATION include)
endif()
if (LIBTBBMALLOC)
  install(FILES ${LIBTBBMALLOC} DESTINATION lib)
endif()
if (LIBTBBMALLOC_PROXY)
  install(FILES ${LIBTBBMALLOC_PROXY} DESTINATION lib)
endif()

add_test(NAME simple-align
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2 -x example/index/lambda_virus example/reads/longreads.fq -u 10)
add_test(NAME simple-build
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2-build-s -c GGGCGGCGACCTCGCGGGTTTTCGCTA out)
add_test(NAME simple-inspect
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2-inspect-s out && rm out*)

=== Makefile ===
--- 
+++ 
@@ -24,6 +24,7 @@
 PREFIX := /usr/local
 bindir := $(PREFIX)/bin
 
+ARCH := $(shell uname -m)
 LDLIBS := -lz
 GCC_PREFIX := $(shell dirname `which gcc`)
 GCC_SUFFIX :=
@@ -187,7 +188,7 @@
 BUILD_CPPS_MAIN := $(BUILD_CPPS) bowtie_build_main.cpp
 
 SEARCH_FRAGMENTS := $(wildcard search_*_phase*.c)
-VERSION := $(shell cat VERSION)
+VERSION := $(shell cat BOWTIE2_VERSION)
 
 SANITIZER_FLAGS :=
 ifeq (0,$(shell $(CXX) -E -fsanitize=address,undefined btypes.h > /dev/null 2>&1; echo $$?))
@@ -207,18 +208,18 @@
 else ifeq (aarch64,$(shell uname -m))
   BITS := 64
   SSE_FLAG :=
-  CXXFLAGS := -fopenmp-simd
-  CPPFLAGS := -Ithird_party/simde
+  CXXFLAGS += -fopenmp-simd
+  CPPFLAGS += -Ithird_party/simde
 else ifeq (s390x,$(shell uname -m))
   BITS := 64
   SSE_FLAG :=
-  CXXFLAGS := -fopenmp-simd
-  CPPFLAGS := -Ithird_party/simde
+  CXXFLAGS += -fopenmp-simd
+  CPPFLAGS += -Ithird_party/simde
   SANITIZER_FLAGS :=
 else ifeq (ppc64le,$(shell uname -m))
   BITS := 64
   SSE_FLAG :=
-  CXXFLAGS := -fopenmp-simd
+  CXXFLAGS += -fopenmp-simd
   CPPFLAGS += -Ithird_party/simde
   SANITIZER_FLAGS :=
 endif
@@ -282,7 +283,7 @@
   MANUAL.markdown \
   README.md \
   TUTORIAL \
-  VERSION
+  BOWTIE2_VERSION
 
 ifeq (1,$(WINDOWS))
   BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
@@ -321,8 +322,8 @@
 both-sanitized: bowtie2-align-s-sanitized bowtie2-build-s-sanitized bowtie2-align-l-sanitized bowtie2-build-l-sanitized ;
 
 DEFS := -fno-strict-aliasing \
-  -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
-  -DBUILD_HOST="\"${HOSTNAME:-`hostname`}\"" \
+  -DBOWTIE2_VERSION="\"`cat BOWTIE2_VERSION`\"" \
+  -DBUILD_HOST="\"$${HOSTNAME:-`hostname`}\"" \
   -DBUILD_TIME="\"`date -u`\"" \
   -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
   $(FILE_FLAGS) \
@@ -419,7 +420,7 @@
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) -I . \
+		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
@@ -428,7 +429,7 @@
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
-		$(CPPFLAGS) -I . \
+		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
@@ -437,7 +438,7 @@
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(CXXFLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) -I . \
+		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)

=== debian/changelog ===
bowtie2 (2.4.2-2) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * Patch Makefile to set date for BUILD_TIME using SOURCE_DATE_EPOCH.
    Closes: #977435
  * Force same hostname to enable reproducible builds
    Closes: #977436

  [ Andreas Tille ]
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * use binaries installed to debian/tmp

 -- Andreas Tille <tille@debian.org>  Tue, 15 Dec 2020 21:07:56 +0100

bowtie2 (2.4.2-1) unstable; urgency=medium

  * New upstream version 2.4.2
  * Refresh patches,
    drop applied by upstream gcc10_ftbfs_invalid_dquote_char.patch
  * Apply cme fix dpkg, drop version from libsimde-dev

 -- Alexandre Mestiashvili <mestia@debian.org>  Wed, 07 Oct 2020 20:06:52 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                help2man,
                libtbb-dev,
                python3,
@@ -13,22 +13,21 @@
                libclone-perl,
                libfile-which-perl,
                zlib1g-dev,
-               libsimde-dev (>= 0.0.0.git.20200526)
-Standards-Version: 4.5.0
-Rules-Requires-Root: no
+               libsimde-dev
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
 Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
+Rules-Requires-Root: no
 
 Package: bowtie2
 Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 m68k ppc64 riscv64 sh4 sparc64
-# "any-64bit" :-)
-Built-Using: ${simde:Built-Using}
 Depends: python3,
          ${misc:Depends},
          ${shlibs:Depends},
          ${perl:Depends}
 Suggests: bowtie2-examples
+Built-Using: ${simde:Built-Using}
 Description: ultrafast memory-efficient short read aligner
  is an ultrafast and memory-efficient tool for aligning sequencing reads
  to long reference sequences. It is particularly good at aligning reads

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	dh $@
 
 override_dh_auto_build:
-	LD_PRELOAD= dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
+	LD_PRELOAD= dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) HOSTNAME=reproducible-hostname
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

=== debian/tests/control ===
Tests: check-wo-arguments

Tests: indexing-ref-genome

Tests: binary-run

=== debian/watch ===
version=4

https://github.com/BenLangmead/bowtie2/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## bowtie2 2.4.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
 
 cmake_policy(SET CMP0048 NEW)
 cmake_policy(SET CMP0005 NEW)
@@ -16,21 +16,22 @@
 ProcessorCount(NUM_CORES)
 
 option(BOWTIE_MM "enable bowtie2 memory mapping" ON)
-option(BOWITE_SHARED_MM "enable shared memory mapping" ON)
-
-set(NO_TBB ${NO_TBB})
-set(NO_SPINLOCK ${NO_SPINLOCK})
+option(BOWTIE_SHARED_MEM "enable shared memory mapping" OFF)
+
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
 set(USE_SRA ${USE_SRA})
 set(WITH_THREAD_PROFILING ${WITH_THREAD_PROFILING})
-set(NO_POPCNT_CAPABILITY ${NO_POPCNT_CAPABILITY})
 set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
 set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -g3 -Wall -msse2")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64 -g3 -Wall")
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
 set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops")
 set(INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")
 
-set(CMAKE_EXPORT_COMPILE_COMMANDS on)
+include_directories(${SOURCE_DIR}/third_party)
 
 if (MINGW)
   option(BOWTIE_MM "Memory mapped files not supported on Windows" OFF)
@@ -65,6 +66,7 @@
   edit.cpp
   bt2_idx.cpp
   bt2_io.cpp
+  bt2_locks.cpp
   bt2_util.cpp
   reference.cpp
   ds.cpp
@@ -119,6 +121,14 @@
   -D_GNU_SOURCE
   )
 
+if (BOWTIE_MM)
+  add_definitions(-DBOWTIE_MM)
+endif()
+
+if (BOWTIE_SHARED_MEM)
+  add_definitions(-DBOWTIE_SHARED_MEM)
+endif()
+
 if (WITH_AFFINITY)
   add_definitions(-DWITH_AFFINITY=1)
 endif()
@@ -127,9 +137,17 @@
   add_definitions(-DNO_SPINLOCK)
 endif()
 
-if (NOT NO_POPCNT_CAPABILITY)
+if (NOT NO_QUEUELOCK)
+  add_definitions(-DNO_SPINLOCK)
+  add_definitions(-DWITH_QUEUELOCK=1)
+endif()
+
+ execute_process(COMMAND uname -m OUTPUT_VARIABLE ARCH)
+if (${ARCH} MATCHES aarch64|arm64|390x|ppc64|ppc64le)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd")
+elseif (${ARCH} MATCHES amd64|x64_64)
   add_definitions(-DPOPCNT_CAPABILITY)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I third_party")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
 endif()
 
 if (USE_SRA)
@@ -199,81 +217,18 @@
 
 if (CMAKE_BUILD_TYPE STREQUAL "Release")
   add_definitions(-DNDEBUG)
+else()
+  message("--------------------------------------------------------------------------")
+  message("ATTN: Targets built in debug mode will have `-debug' appended to its name.")
+  message("See https://cmake.org/cmake/help/latest/variable/CMAKE_BUILD_TYPE.html")
+  message("--------------------------------------------------------------------------")
+  set(CMAKE_EXECUTABLE_SUFFIX "-debug")
 endif()
 
 find_package(ZLIB REQUIRED)
-
 
 find_package(Threads REQUIRED)
 link_libraries(Threads::Threads)
-
-if (NO_TBB)
-  set(SHARED_CPPS ${SHARED_CPPS} tinythread.cpp)
-else()
-  find_library(TBB_LIB_PATH tbb)
-  if (TBB_LIB_PATH)
-    find_path(TBB_INCLUDE_PATH tbb/tbb.h)
-    link_libraries(${TBB_LIB_PATH})
-    find_library(TBBMALLOC_PROXY_LIB_PATH tbbmalloc_proxy)
-    if (NOT TBBMALLOC_PROXY_LIB_PATH)
-      find_library(TBBMALLOC_LIB_PATH tbbmalloc)
-      link_libraries(${TBBMALLOC_LIB_PATH})
-    else()
-      link_libraries(${TBBMALLOC_PROXY_LIB_PATH})
-    endif()
-    include_directories(${TBB_INCLUDE_PATH})
-  else()
-    set(TBB_VER 2019_U4)
-
-    if (CMAKE_SYSTEM_NAME STREQUAL Linux)
-      set(tbb_os linux)
-    elseif (CMAKE_SYSTEM_NAME STREQUAL Darwin)
-      set(tbb_os macos)
-    elseif (CMAKE_SYSTEM_NAME STREQUAL Windows)
-      set(tbb_os windows)
-    else()
-      set(tbb_os ${CMAKE_SYSTEM_NAME})
-    endif()
-
-    find_program(MAKE_EXE NAMES gmake nmake make)
-    ExternalProject_Add(tbb_project
-      URL https://github.com/01org/tbb/archive/2019_U4.tar.gz
-      PREFIX ${CMAKE_CURRENT_BINARY_DIR}/tbb-${TBB_VER}
-      BUILD_IN_SOURCE 1
-      CONFIGURE_COMMAND ""
-      BUILD_COMMAND ${MAKE_EXE} tbb_build_prefix=${TBB_VER} tbb_os=${tbb_os}
-      INSTALL_COMMAND ""
-      PREFIX=${CMAKE_CURRENT_BINARY_DIR}/tbb_project
-      )
-
-    ExternalProject_Get_Property(tbb_project SOURCE_DIR)
-    set(TBB_SOURCE_DIR ${SOURCE_DIR})
-    set(TBB_RELEASE_DIR ${TBB_SOURCE_DIR}/build/${TBB_VER}_release)
-    include_directories(${TBB_SOURCE_DIR}/include)
-    find_path(TBB_INCLUDE_PATH PATHS ${TBB_SOURCE_DIR}/include NAMES tbb/tbb.h)
-
-    link_directories(${TBB_RELEASE_DIR})
-    add_library(tbb SHARED IMPORTED)
-    add_dependencies(tbb tbb_project)
-    find_library(LIBTBB tbb PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
-    set_property(TARGET tbb PROPERTY IMPORTED_LOCATION ${LIBTBB})
-
-    add_library(tbbmalloc_proxy SHARED IMPORTED)
-    add_dependencies(tbbmalloc_proxy tbb_project)
-    find_library(LIBTBBMALLOC_PROXY tbbmalloc_proxy PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
-    if (NOT LIBTBBMALLOC_PROXY)
-      add_library(tbbmalloc SHARED IMPORTED)
-      add_dependencies(tbbmalloc tbb_project)
-      find_library(LIBTBBMALLOC tbbmalloc PATHS ${TBB_RELEASE_DIR} NO_DEFAULT_PATH)
-      set_property(TARGET tbbmalloc PROPERTY IMPORTED_LOCATION ${LIBTBBMALLOC})
-      link_libraries(tbb tbbmalloc)
-    else()
-      set_property(TARGET tbbmalloc_proxy PROPERTY IMPORTED_LOCATION ${LIBTBBMALLOC_PROXY})
-      link_libraries(tbb tbbmalloc_proxy)
-    endif()
-  endif()
-  add_definitions(-DWITH_TBB -DWITH_QUEUELOCK=1 -DNO_SPINLOCK)
-endif()
 
 if (ZLIB_FOUND)
   link_libraries(${ZLIB_LIBRARIES})
@@ -293,22 +248,11 @@
 
 set_target_properties(bowtie2-align-l bowtie2-build-l bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE2_64BIT_INDEX")
 set_target_properties(bowtie2-inspect-s bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE_INSPECT_MAIN")
-# set_target_properties(${BOWTIE2_BIN_LIST} PROPERTIES DEBUG_POSTFIX -debug)
 
 install(TARGETS ${BOWTIE2_BIN_LIST} DESTINATION bin)
 install(FILES ${BOWTIE2_WRAPPER_SCRIPTS}
   PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
   DESTINATION bin)
-if (LIBTBB)
-  install(FILES ${LIBTBB} DESTINATION lib)
-  install(DIRECTORY ${TBB_INCLUDE_PATH} DESTINATION include)
-endif()
-if (LIBTBBMALLOC)
-  install(FILES ${LIBTBBMALLOC} DESTINATION lib)
-endif()
-if (LIBTBBMALLOC_PROXY)
-  install(FILES ${LIBTBBMALLOC_PROXY} DESTINATION lib)
-endif()
 
 add_test(NAME simple-align
   WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}

=== Makefile ===
--- 
+++ 
@@ -24,18 +24,15 @@
 PREFIX := /usr/local
 bindir := $(PREFIX)/bin
 
-ARCH := $(shell uname -m)
-LDLIBS := -lz
-GCC_PREFIX := $(shell dirname `which gcc`)
-GCC_SUFFIX :=
-CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
-CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
-CXX ?= $(CPP)
+LDLIBS := -lpthread -lz
 
 HEADERS := $(wildcard *.h)
 BOWTIE_MM := 1
 BOWTIE_SHARED_MEM :=
 
+CXXFLAGS += -std=c++11
+
+ARCH = $(shell uname -m)
 NGS_VER ?= 2.9.2
 VDB_VER ?= 2.9.2-1
 
@@ -61,12 +58,34 @@
   endif
 endif
 
+BITS := 32
+ifneq (,$(findstring $(shell uname -m), x86_64 amd64))
+  BITS := 64
+  SSE_FLAG := -msse2
+  POPCNT_CAPABILITY ?= 1
+else ifneq (,$(findstring $(shell uname -m), aarch64 arm64 s390x ppc64 ppc64le))
+  BITS := 64
+  SSE_FLAG :=
+  CXXFLAGS += -fopenmp-simd
+  CPPFLAGS += -Ithird_party
+  POPCNT_CAPABILITY ?= 0
+endif
+
+# msys will always be 32 bit so look at the cpu arch instead.
+ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
+  ifeq (1,$(MINGW))
+    BITS := 64
+  endif
+endif
+ifeq (32,$(BITS))
+  $(error bowtie2 compilation requires a 64-bit platform )
+endif
+
 ifdef STATIC_BUILD
   LDFLAGS += -L$(CURDIR)/.tmp/lib
   CPPFLAGS += -I$(CURDIR)/.tmp/include
 endif
 
-POPCNT_CAPABILITY ?= 1
 ifeq (1, $(POPCNT_CAPABILITY))
   CXXFLAGS += -DPOPCNT_CAPABILITY
   CPPFLAGS += -I third_party
@@ -86,11 +105,6 @@
 
 PTHREAD_PKG :=
 PTHREAD_LIB :=
-
-#if we're not using TBB, then we can't use queuing locks
-ifeq (1,$(NO_TBB))
-  NO_QUEUELOCK := 1
-endif
 
 ifeq (1,$(MINGW))
   PTHREAD_LIB :=
@@ -100,22 +114,6 @@
 
 ifeq (1,$(NO_SPINLOCK))
   CXXFLAGS += -DNO_SPINLOCK
-endif
-
-#default is to use Intel TBB
-ifneq (1,$(NO_TBB))
-  LDLIBS += $(PTHREAD_LIB) -ltbb
-  ifdef STATIC_BUILD
-    LDLIBS += -ltbbmalloc
-    ifndef MINGW
-      LDLIBS += -ldl
-    endif
-  else
-    LDLIBS += -ltbbmalloc_proxy
-  endif
-  CXXFLAGS += -DWITH_TBB -std=c++11
-else
-  LDLIBS += $(PTHREAD_LIB)
 endif
 
 USE_SRA ?=
@@ -143,20 +141,16 @@
   CXXFLAGS += -DWITH_AFFINITY=1
 endif
 
-#default is to use Intel TBB's queuing lock for better thread scaling performance
+#default is to use queue lock for better thread scaling performance
 ifneq (1,$(NO_QUEUELOCK))
   CXXFLAGS += -DNO_SPINLOCK
   CXXFLAGS += -DWITH_QUEUELOCK=1
 endif
 
 SHARED_CPPS :=  ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
-  edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
+  edit.cpp bt2_locks.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
   reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
   random_source.cpp
-
-ifeq (1,$(NO_TBB))
-  SHARED_CPPS += tinythread.cpp
-endif
 
 SEARCH_CPPS :=  qual.cpp pat.cpp sam.cpp \
   read_qseq.cpp aligner_seed_policy.cpp \
@@ -177,6 +171,11 @@
   aligner_swsse_ee_u8.cpp \
   aligner_driver.cpp
 
+ifeq (1, $(WITH_ZSTD))
+  LDLIBS += -lzstd
+  SHARED_CPPS += zstd_decompress.cpp
+endif
+
 SEARCH_CPPS_MAIN := $(SEARCH_CPPS) bowtie_main.cpp
 
 DP_CPPS := qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
@@ -197,40 +196,6 @@
   SANITIZER_FLAGS := -fsanitize=address
 else ifeq (0,$(shell $(CXX) -E -fsanitize=undefined btypes.h > /dev/null 2>&1; echo $$?))
   SANITIZER_FLAGS := -fsanitize=undefined
-endif
-
-BITS := 32
-SSE_FLAG := -msse2
-ifeq (x86_64,$(shell uname -m))
-  BITS := 64
-else ifeq (amd64,$(shell uname -m))
-  BITS := 64
-else ifeq (aarch64,$(shell uname -m))
-  BITS := 64
-  SSE_FLAG :=
-  CXXFLAGS += -fopenmp-simd
-  CPPFLAGS += -Ithird_party/simde
-else ifeq (s390x,$(shell uname -m))
-  BITS := 64
-  SSE_FLAG :=
-  CXXFLAGS += -fopenmp-simd
-  CPPFLAGS += -Ithird_party/simde
-  SANITIZER_FLAGS :=
-else ifeq (ppc64le,$(shell uname -m))
-  BITS := 64
-  SSE_FLAG :=
-  CXXFLAGS += -fopenmp-simd
-  CPPFLAGS += -Ithird_party/simde
-  SANITIZER_FLAGS :=
-endif
-# msys will always be 32 bit so look at the cpu arch instead.
-ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
-  ifeq (1,$(MINGW))
-    BITS := 64
-  endif
-endif
-ifeq (32,$(BITS))
-  $(error bowtie2 compilation requires a 64-bit platform )
 endif
 
 DEBUG_FLAGS    := -O0 -g3 $(SSE_FLAG)
@@ -287,11 +252,7 @@
 
 ifeq (1,$(WINDOWS))
   BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
-  ifneq (1,$(NO_TBB))
-    CXXFLAGS += -static-libgcc -static-libstdc++
-  else
-    CXXFLAGS += -static -static-libgcc -static-libstdc++
-  endif
+  CXXFLAGS += -static-libgcc -static-libstdc++
 endif
 
 # This is helpful on Windows under MinGW/MSYS, where Make might go for
@@ -443,3 +404,36 @@
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
 
+bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(CXXFLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
+		$(CPPFLAGS) \
+		-o $@ $< \
+		$(SHARED_CPPS) \
+		$(LDFLAGS) $(LDLIBS)
+
+#
+# bowtie2-dp targets
+#
+
+bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
+	$(CXX) $(RELEASE_FLAGS) \
+		$(RELEASE_DEFS) $(CXXFLAGS) $(NOASSERT_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
+		$(CPPFLAGS) \
+		-o $@ $< \
+		$(DP_CPPS) $(SHARED_CPPS) \
+		$(LDFLAGS) $(LDLIBS)
+
+bowtie2-dp-debug: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(CXXFLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
+		$(CPPFLAGS) \
+		-o $@ $< \
+		$(DP_CPPS) $(SHARED_CPPS) \
+		$(LDFLAGS) $(LDLIBS)
+
+bowtie2.bat:
+	echo "@echo off" > bowtie2.bat

=== debian/changelog ===
bowtie2 (2.4.4-1) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Refresh patches

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 13 Sep 2021 18:45:11 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libfile-which-perl,
                zlib1g-dev,
                libsimde-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
 Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2

=== debian/watch ===
version=4

https://github.com/BenLangmead/bowtie2/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## bowtie2 2.4.5

=== Makefile ===
--- 
+++ 
@@ -43,6 +43,9 @@
   WINDOWS := 1
   MINGW := 1
   # POSIX memory-mapped files not currently supported on Windows
+endif
+
+ifeq (1, $(WINDOWS))
   BOWTIE_MM :=
   BOWTIE_SHARED_MEM :=
 endif
@@ -252,7 +255,7 @@
 
 ifeq (1,$(WINDOWS))
   BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
-  CXXFLAGS += -static-libgcc -static-libstdc++
+  CXXFLAGS += -static-libgcc -static-libstdc++ -static
 endif
 
 # This is helpful on Windows under MinGW/MSYS, where Make might go for
@@ -436,4 +439,3 @@
 		$(LDFLAGS) $(LDLIBS)
 
 bowtie2.bat:
-	echo "@echo off" > bowtie2.bat

=== debian/changelog ===
bowtie2 (2.4.5-1) unstable; urgency=medium

  * New upstream version
  * Drop transition for old debug package migration.

 -- Andreas Tille <tille@debian.org>  Thu, 17 Feb 2022 16:46:58 +0100

=== debian/rules ===
--- 
+++ 
@@ -38,9 +38,6 @@
 	LD_PRELOAD= make -j1 test
 endif
 
-override_dh_auto_install:
-	dh_auto_install
-
 override_dh_install:
 	dh_install -X.gitignore
